/*

 Licensed under the Apache License, Version 2.0 (the "License"); you may not
 use this file except in compliance with the License. You may obtain a copy
 of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 License for the specific language governing permissions and limitations under
 the License.

 Copyright (c) 2011-2012 Almende B.V.

 @author 	Jos de Jong, <jos@almende.org>
 @date    2012-06-04
 @version 1.2
*/
typeof links==="undefined"&&(links={});typeof google==="undefined"&&(google=void 0);
links.Network=function(a){this.containerElement=a;this.height=this.width="100%";this.refreshRate=50;this.selectable=this.stabilize=!0;this.constants={nodes:{radiusMin:5,radiusMax:20,radius:5,distance:100,style:"rect",image:void 0,widthMin:16,widthMax:64,fontColor:"black",fontSize:14,fontFace:"arial",borderColor:"#2B7CE9",backgroundColor:"#97C2FC",highlightColor:"#D2E5FF",group:void 0},links:{widthMin:1,widthMax:15,width:1,style:"line",color:"#2B7CE9",length:50,distance:100},packages:{radius:5,radiusMin:5,
radiusMax:10,style:"dot",color:"#2B7CE9",image:void 0,widthMin:16,widthMax:64,duration:1},minVelocity:0.01,maxIterations:1E3};this.nodes=[];this.links=[];this.packages=[];this.images=new links.Network.Images;this.groups=new links.Network.Groups;this.hasMovingPackages=this.hasMovingNodes=this.hasMovingLinks=!1;this.selection=[];this.timer=void 0;this._create()};
links.Network.prototype.draw=function(a,b,c,d){var e,f,g;d!=void 0?(e=a,f=b,g=c):c!=void 0?(e=a,f=b,g=void 0,d=c):b!=void 0?(e=a,g=f=void 0,d=b):a!=void 0&&(g=f=e=void 0,d=a);if(d!=void 0){if(d.width!=void 0)this.width=d.width;if(d.height!=void 0)this.height=d.height;if(d.stabilize!=void 0)this.stabilize=d.stabilize;if(d.selectable!=void 0)this.selectable=d.selectable;if(d.links){for(var i in d.links)d.links.hasOwnProperty(i)&&(this.constants.links[i]=d.links[i]);if(d.links.length!=void 0&&d.links.distance==
void 0)this.constants.links.length=d.links.length,this.constants.nodes.distance=d.links.length*1.25}if(d.nodes)for(i in d.nodes)d.nodes.hasOwnProperty(i)&&(this.constants.nodes[i]=d.nodes[i]);if(d.packages)for(i in d.packages)d.packages.hasOwnProperty(i)&&(this.constants.packages[i]=d.packages[i]);if(d.groups)for(var h in d.groups)d.groups.hasOwnProperty(h)&&this.groups.add(h,d.groups[h])}this._setBackgroundColor(d.backgroundColor);this._setSize(this.width,this.height);this._setTranslation(0,0);this._setScale(1);
this.hasTimestamps=!1;this.setNodes(e);this.setLinks(f);this.setPackages(g);this._reposition();this.stabilize&&this._doStabilize();this.start();var j=this;this.images.setOnloadCallback(function(){j._redraw()});this.trigger("ready")};links.Network.prototype.trigger=function(a,b){links.events.trigger(this,a,b);google&&google.visualization&&google.visualization.events&&google.visualization.events.trigger(this,a,b)};
links.Network.prototype._create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div");this.frame.className="network-frame";this.frame.style.position="relative";this.frame.style.overflow="hidden";this.frame.canvas=document.createElement("canvas");this.frame.canvas.style.position="relative";this.frame.appendChild(this.frame.canvas);if(!this.frame.canvas.getContext){var a=document.createElement("DIV");
a.style.color="red";a.style.fontWeight="bold";a.style.padding="10px";a.innerHTML="Error: your browser does not support HTML canvas";this.frame.canvas.appendChild(a)}var b=this;links.Network.addEventListener(this.frame.canvas,"mousedown",function(a){b._onMouseDown(a)});links.Network.addEventListener(this.frame.canvas,"mousemove",function(a){b._onMouseMoveTitle(a)});links.Network.addEventListener(this.frame.canvas,"mousewheel",function(a){b._onMouseWheel(a)});links.Network.addEventListener(this.frame.canvas,
"touchstart",function(a){b._onTouchStart(a)});this.containerElement.appendChild(this.frame)};
links.Network.prototype._setBackgroundColor=function(a){var b="white",c="lightgray",d=1;if(typeof a=="string")b=a,c="none",d=0;else if(typeof a=="object"){if(a.fill!=void 0)b=a.fill;if(a.stroke!=void 0)c=a.stroke;if(a.strokeWidth!=void 0)d=a.strokeWidth}else if(a!=void 0)throw"Unsupported type of backgroundColor";this.frame.style.backgroundColor=b;this.frame.style.borderColor=c;this.frame.style.borderWidth=d+"px";this.frame.style.borderStyle="solid"};
links.Network.prototype._onMouseDown=function(a){a=a||window.event;if(this.selectable&&(this.leftButtonDown&&this._onMouseUp(a),(this.leftButtonDown=a.which?a.which==1:a.button==1)||this.touchDown)){var b=this;this.onmousemove=function(a){b._onMouseMove(a)};this.onmouseup=function(a){b._onMouseUp(a)};links.Network.addEventListener(document,"mousemove",b.onmousemove);links.Network.addEventListener(document,"mouseup",b.onmouseup);links.Network.preventDefault(a);this.startMouseX=a.clientX||a.targetTouches[0].clientX;
this.startMouseY=a.clientY||a.targetTouches[0].clientY;this.startFrameLeft=links.Network._getAbsoluteLeft(this.frame.canvas);this.startFrameTop=links.Network._getAbsoluteTop(this.frame.canvas);this.startTranslation=this._getTranslation();this.ctrlKeyDown=a.ctrlKey;this.shiftKeyDown=a.shiftKey;a=this._getNodesOverlappingWith({left:this._xToCanvas(this.startMouseX-this.startFrameLeft),top:this._yToCanvas(this.startMouseY-this.startFrameTop),right:this._xToCanvas(this.startMouseX-this.startFrameLeft),
bottom:this._yToCanvas(this.startMouseY-this.startFrameTop)});if(this.startClickedObj=a.length>0?a[a.length-1]:void 0)a=this.nodes[this.startClickedObj.row],this.startClickedObj.xFixed=a.xFixed,this.startClickedObj.yFixed=a.yFixed,a.xFixed=!0,a.yFixed=!0,!this.ctrlKeyDown||!a.isSelected()?this._selectNodes([this.startClickedObj],this.ctrlKeyDown):this._unselectNodes([this.startClickedObj]),this.hasMovingNodes||this._redraw();else if(!this.shiftKeyDown)this.moved=!1}};
links.Network.prototype._onMouseMove=function(a){a=a||window.event;if(this.selectable){var b=a.clientX||a.targetTouches&&a.targetTouches[0].clientX||0,c=a.clientY||a.targetTouches&&a.targetTouches[0].clientY||0;this.mouseX=b;this.mouseY=c;if(this.startClickedObj){var d=this.nodes[this.startClickedObj.row];if(!this.startClickedObj.xFixed)d.x=this._xToCanvas(b-this.startFrameLeft);if(!this.startClickedObj.yFixed)d.y=this._yToCanvas(c-this.startFrameTop);if(!this.hasMovingNodes)this.hasMovingNodes=!0,
this.start()}else if(this.shiftKeyDown){if(this.frame.selRect==void 0)this.frame.selRect=document.createElement("DIV"),this.frame.appendChild(this.frame.selRect),this.frame.selRect.style.position="absolute",this.frame.selRect.style.border="1px dashed red";var d=Math.min(this.startMouseX,b)-this.startFrameLeft,e=Math.min(this.startMouseY,c)-this.startFrameTop,b=Math.max(this.startMouseX,b)-this.startFrameLeft,c=Math.max(this.startMouseY,c)-this.startFrameTop;this.frame.selRect.style.left=d+"px";this.frame.selRect.style.top=
e+"px";this.frame.selRect.style.width=b-d+"px";this.frame.selRect.style.height=c-e+"px"}else this._setTranslation(this.startTranslation.x+(b-this.startMouseX),this.startTranslation.y+(c-this.startMouseY)),this._redraw(),this.moved=!0;links.Network.preventDefault(a)}};
links.Network.prototype._onMouseUp=function(a){a=a||window.event;if(this.selectable){links.Network.removeEventListener(document,"mousemove",this.onmousemove);links.Network.removeEventListener(document,"mouseup",this.onmouseup);links.Network.preventDefault(a);var b=a.clientX||this.mouseX||0,c=a.clientY||this.mouseY||0,a=a?a.ctrlKey:window.event.ctrlKey;if(this.startClickedObj)b=this.nodes[this.startClickedObj.row],b.xFixed=this.startClickedObj.xFixed,b.yFixed=this.startClickedObj.yFixed;else if(this.shiftKeyDown){if(this._selectNodes(this._getNodesOverlappingWith({left:this._xToCanvas(Math.min(this.startMouseX,
b)-this.startFrameLeft),top:this._yToCanvas(Math.min(this.startMouseY,c)-this.startFrameTop),right:this._xToCanvas(Math.max(this.startMouseX,b)-this.startFrameLeft),bottom:this._yToCanvas(Math.max(this.startMouseY,c)-this.startFrameTop)}),a),this.redraw(),this.frame.selRect)this.frame.removeChild(this.frame.selRect),this.frame.selRect=void 0}else!this.ctrlKeyDown&&!this.moved&&(this._unselectNodes(),this._redraw());this.ctrlKeyDown=this.leftButtonDown=!1}};
links.Network.prototype._onMouseWheel=function(a){var a=a||window.event,b=a.clientX,c=a.clientY,d=0;a.wheelDelta?d=a.wheelDelta/120:a.detail&&(d=-a.detail/3);if(d){var e=d/10;d<0&&(e/=1-e);d=this._getScale();e=d*(1+e);e<0.01&&(e=0.01);e>10&&(e=10);var f=links.Network._getAbsoluteLeft(this.frame.canvas),g=links.Network._getAbsoluteTop(this.frame.canvas);b-=f;c-=g;g=this._getTranslation();d=e/d;b=(1-d)*b+g.x*d;d=(1-d)*c+g.y*d;this._setScale(e);this._setTranslation(b,d);this._redraw()}links.Network.preventDefault(a)};
links.Network.prototype._onMouseMoveTitle=function(a){var a=a||window.event,b=a.clientX,a=a.clientY;this.startFrameLeft=this.startFrameLeft||links.Network._getAbsoluteLeft(this.frame.canvas);this.startFrameTop=this.startFrameTop||links.Network._getAbsoluteTop(this.frame.canvas);var c=b-this.startFrameLeft,d=a-this.startFrameTop;this.popupNode&&this._checkHidePopup(c,d);var e=this,b=function(){e._checkShowPopup(c,d)};this.popupTimer&&clearInterval(this.popupTimer);if(!this.leftButtonDown)this.popupTimer=
setTimeout(b,300)};
links.Network.prototype._checkShowPopup=function(a,b){var c={left:this._xToCanvas(a),top:this._yToCanvas(b),right:this._xToCanvas(a),bottom:this._yToCanvas(b)},d,e,f=this.popupNode;if(this.popupNode==void 0)for(d=0,e=this.packages.length;d<e;d++){var g=this.packages[d];if(g.getTitle()!=void 0&&g.isOverlappingWith(c)){this.popupNode=g;break}}if(this.popupNode==void 0){e=this.nodes;for(d=e.length-1;d>=0;d--)if(g=e[d],g.getTitle()!=void 0&&g.isOverlappingWith(c)){this.popupNode=g;break}}if(this.popupNode==
void 0){g=this.links;for(d=0,e=g.length;d<e;d++){var i=g[d];if(i.getTitle()!=void 0&&i.isOverlappingWith(c)){this.popupNode=i;break}}}if(this.popupNode){if(this.popupNode!=f){if(!this.popup)this.popup=new links.Network.Popup(this.frame);this.popup.setPosition(a-3,b-3);this.popup.setText(this.popupNode.getTitle());this.popup.show()}}else this.popup&&this.popup.hide()};
links.Network.prototype._checkHidePopup=function(a,b){var c={left:a,top:b,right:a,bottom:b};if(!this.popupNode||!this.popupNode.isOverlappingWith(c))this.popupNode=void 0,this.popup&&this.popup.hide()};
links.Network.prototype._onTouchStart=function(a){this.touchDown=!0;var b=this;this.ontouchmove=function(a){b._onTouchMove(a)};this.ontouchend=function(a){b._onTouchEnd(a)};links.Network.addEventListener(document,"touchmove",b.ontouchmove);links.Network.addEventListener(document,"touchend",b.ontouchend);this._onMouseDown(a)};links.Network.prototype._onTouchMove=function(a){this._onMouseMove(a)};
links.Network.prototype._onTouchEnd=function(a){this.touchDown=!1;links.Network.removeEventListener(document,"touchmove",this.ontouchmove);links.Network.removeEventListener(document,"touchend",this.ontouchend);this._onMouseUp(a)};
links.Network.prototype._unselectNodes=function(a,b){var c=!1,d,e,f;if(a)for(d=0,e=a.length;d<e;d++){f=a[d].row;this.nodes[f].unselect();for(var g=0;g<this.selection.length;)this.selection[g].row==f?(this.selection.splice(g,1),c=!0):g++}else if(this.selection&&this.selection.length){for(d=0,e=this.selection.length;d<e;d++)f=this.selection[d].row,this.nodes[f].unselect(),c=!0;this.selection=[]}c&&(b==!0||b==void 0)&&this.trigger("select");return c};
links.Network.prototype._selectNodes=function(a,b){var c=!1,d,e,f=!0;if(a.length!=this.selection.length)f=!1;else for(d=0,e=Math.min(a.length,this.selection.length);d<e;d++)if(a[d].row!=this.selection[d].row){f=!1;break}if(f)return c;if(b==void 0||b==!1)c=this._unselectNodes(void 0,!1);for(d=0,e=a.length;d<e;d++){for(var f=a[d].row,g=!1,i=0,h=this.selection.length;i<h;i++)if(this.selection[i].row==f){g=!0;break}g||(this.nodes[f].select(),this.selection.push(a[d]),c=!0)}c&&this.trigger("select");return c};
links.Network.prototype._getNodesOverlappingWith=function(a){for(var b=[],c=0;c<this.nodes.length;c++)this.nodes[c].isOverlappingWith(a)&&b.push({row:c});return b};links.Network.prototype.getSelection=function(){for(var a=[],b=0;b<this.selection.length;b++)a.push({row:this.selection[b].row});return a};
links.Network.prototype.setSelection=function(a){var b,c,d;if(a.length==void 0)throw"Selection must be an array with objects";for(b=0,c=this.selection.length;b<c;b++)d=this.selection[b].row,this.nodes[d].unselect();this.selection=[];for(b=0,c=a.length;b<c;b++){d=a[b].row;if(d==void 0)throw"Parameter row missing in selection object";if(d>this.nodes.length-1)throw"Parameter row out of range";this.selection.push({row:d});this.nodes[d].select()}this.redraw()};
links.Network.prototype._getConnectionCount=function(a){function b(a){for(var b=[],d=0,e=a.length;d<e;d++)for(var f=a[d],g=0,i=c.length;g<i;g++){var h=null;if(c[g].from==f)h=c[g].to;else if(c[g].to==f)h=c[g].from;var k,l;if(h)for(k=0,l=a.length;k<l;k++)if(a[k]==h){h=null;break}if(h)for(k=0,l=b.length;k<l;k++)if(b[k]==h){h=null;break}h&&b.push(h)}return b}var c=this.links;a==void 0&&(a=1);var d=[],e=this.nodes,f,g;for(f=0,g=e.length;f<g;f++){for(var i=[e[f]],h=0;h<a;h++)i=i.concat(b(i));d.push(i)}a=
[];for(f=0,len=d.length;f<len;f++)a.push(d[f].length);return a};links.Network.prototype._setSize=function(a,b){this.frame.style.width=a;this.frame.style.height=b;this.frame.canvas.style.width="100%";this.frame.canvas.style.height="100%";this.frame.canvas.width=this.frame.canvas.clientWidth;this.frame.canvas.height=this.frame.canvas.clientHeight;this.slider&&this.slider.redraw()};
links.Network.tableToArray=function(a){var b=[],c,d=a.getNumberOfColumns(),e={};for(c=0;c<d;c++){var f=a.getColumnLabel(c);e[f]=c}d=a.getNumberOfRows();for(f=0;f<d;f++){var g={};for(c in e)e.hasOwnProperty(c)&&(g[c]=a.getValue(f,e[c]));b.push(g)}return b};
links.Network.prototype.addNodes=function(a){if(google&&google.visualization&&google.visualization.DataTable&&a instanceof google.visualization.DataTable)a=links.Network.tableToArray(a);else if(!links.Network.isArray(a))return;for(var b=!1,c=a.length,d=0;d<c;d++){var e=a[d];e.value!=void 0&&(b=!0);if(e.id==void 0)throw"Column 'id' missing in table with nodes (row "+d+")";this._createNode(e)}b&&this._updateValueRange(this.nodes);this.start()};
links.Network.prototype.setNodes=function(a){if(google&&google.visualization&&google.visualization.DataTable&&a instanceof google.visualization.DataTable)a=links.Network.tableToArray(a);else if(!links.Network.isArray(a))return;this.hasMovingNodes=!1;this.nodesTable=a;this.nodes=[];this.selection=[];for(var b=!1,c=a.length,d=0;d<c;d++){var e=a[d];e.value!=void 0&&(b=!0);if(e.timestamp)this.hasTimestamps=this.hasTimestamps||e.timestamp;if(e.id==void 0)throw"Column 'id' missing in table with nodes (row "+
d+")";this._createNode(e)}b&&this._updateValueRange(this.nodes)};links.Network.prototype._filterNodes=function(a){if(this.nodesTable!=void 0){if(a!==void 0)for(var b=this.nodes,c=0;c<b.length;){var d=b[c].timestamp;d!==void 0&&d>a?b.splice(c,1):c++}b=this.nodesTable;c=b.length;for(d=0;d<c;d++){var e=b[d];if(e.id===void 0)throw"Column 'id' missing in table with nodes (row "+d+")";var f=e.timestamp?e.timestamp:void 0,g=!0;f!==void 0&&a!==void 0&&f>a&&(g=!1);g&&this._createNode(e)}this.start()}};
links.Network.prototype._createNode=function(a){var b=a.action?a.action:"update",c,d;if(b==="create"){if(d=new links.Network.Node(a,this.images,this.groups,this.constants),c=a.id,b=c!==void 0?this._findNode(c):void 0,b!==void 0?(a=this.nodes[b],this.nodes[b]=d,a.selected&&this._unselectNodes([{row:b}],!1)):this.nodes.push(d),!d.isFixed())this.hasMovingNodes=!0}else if(b==="update"){c=a.id;if(c===void 0)throw"Cannot update a node without id";b=this._findNode(c);if(b!==void 0)this.nodes[b].setProperties(a);
else if(d=new links.Network.Node(a,this.images,this.groups,this.constants),this.nodes.push(d),!d.isFixed())this.hasMovingNodes=!0}else if(b==="delete"){c=a.id;if(c===void 0)throw"Cannot delete node without its id";b=this._findNode(c);if(b!==void 0)a=this.nodes.splice(b,1),a.selected&&this._unselectNodes([{row:b}],!1);else throw"Node with id "+c+" not found";}else throw"Unknown action "+b+". Choose 'create', 'update', or 'delete'.";};
links.Network.prototype._findNode=function(a){for(var b=this.nodes,c=0,d=b.length;c<d;c++)if(b[c].id===a)return c};links.Network.prototype._findNodeByRow=function(a){return this.nodes[a]};
links.Network.prototype.setLinks=function(a){if(google&&google.visualization&&google.visualization.DataTable&&a instanceof google.visualization.DataTable)a=links.Network.tableToArray(a);else if(!links.Network.isArray(a))return;this.linksTable=a;this.links=[];for(var b=this.hasMovingLinks=!1,c=a.length,d=0;d<c;d++){var e=a[d];if(e.from===void 0)throw"Column 'from' missing in table with links (row "+d+")";if(e.to===void 0)throw"Column 'to' missing in table with links (row "+d+")";if(e.timestamp!=void 0)this.hasTimestamps=
this.hasTimestamps||e.timestamp;e.value!=void 0&&(b=!0);this._createLink(e)}b&&this._updateValueRange(this.links)};
links.Network.prototype.addLinks=function(a){if(google&&google.visualization&&google.visualization.DataTable&&a instanceof google.visualization.DataTable)a=links.Network.tableToArray(a);else if(!links.Network.isArray(a))return;for(var b=!1,c=a.length,d=0;d<c;d++){var e=a[d];if(e.from===void 0)throw"Column 'from' missing in table with links (row "+d+")";if(e.to===void 0)throw"Column 'to' missing in table with links (row "+d+")";e.value!=void 0&&(b=!0);this._createLink(e)}b&&this._updateValueRange(this.links);
this.start()};links.Network.prototype._filterLinks=function(a){if(this.linksTable!=void 0){if(a!==void 0)for(var b=this.links,c=0;c<b.length;){var d=b[c].timestamp;d!==void 0&&d>a?b.splice(c,1):c++}b=this.linksTable;c=b.length;for(d=0;d<c;d++){var e=b[d];if(e.from===void 0)throw"Column 'from' missing in table with links (row "+d+")";if(e.to===void 0)throw"Column 'to' missing in table with links (row "+d+")";var f=e.timestamp?e.timestamp:void 0,g=!0;f!==void 0&&a!==void 0&&f>a&&(g=!1);g&&this._createLink(e)}this.start()}};
links.Network.prototype._createLink=function(a){var b=a.action?a.action:"create",c;if(b==="create"){if(c=a.id,b=c!==void 0?this._findLink(c):void 0,c=new links.Network.Link(a,this,this.constants),b!==void 0?this.links[b]=c:this.links.push(c),c.isMoving())this.hasMovingLinks=!0}else if(b==="update"){c=a.id;if(c===void 0)throw"Cannot update a link without id";b=this._findLink(c);if(b!==void 0)c=this.links[b],c.setProperties(a);else if(c=new links.Network.Link(a,this,this.constants),this.links.push(c),
c.isMoving())this.hasMovingLinks=!0}else if(b==="delete"){c=a.id;if(c===void 0)throw"Cannot delete link without its id";b=this._findLink(c);if(b!==void 0)this.links.splice(b,1);else throw"Link with id "+c+" not found";}else throw"Unknown action "+b+". Choose 'create', 'update', or 'delete'.";};links.Network.prototype._updateNodeReferences=function(a,b){for(var c=[this.links,this.packages],d=0,e=c.length;d<e;d++)for(var f=c[d],g=0,i=f.length;g<i;g++){if(f.from===a)f.from=b;if(f.to===a)f.to=b}};
links.Network.prototype._findLink=function(a){for(var b=this.links,c=0,d=b.length;c<d;c++)if(b[c].id===a)return c};links.Network.prototype._findLinkByRow=function(a){return this.links[a]};
links.Network.prototype.addPackages=function(a){if(google&&google.visualization&&google.visualization.DataTable&&a instanceof google.visualization.DataTable)a=links.Network.tableToArray(a);else if(!links.Network.isArray(a))return;for(var b=a.length,c=0;c<b;c++){var d=a[c];if(d.from===void 0)throw"Column 'from' missing in table with packages (row "+c+")";if(d.to===void 0)throw"Column 'to' missing in table with packages (row "+c+")";this._createPackage(d)}this._updateValueRange(this.packages);this.start()};
links.Network.prototype.setPackages=function(a){if(google&&google.visualization&&google.visualization.DataTable&&a instanceof google.visualization.DataTable)a=links.Network.tableToArray(a);else if(!links.Network.isArray(a))return;this.packagesTable=a;this.packages=[];for(var b=a.length,c=0;c<b;c++){var d=a[c];if(d.from===void 0)throw"Column 'from' missing in table with packages (row "+c+")";if(d.to===void 0)throw"Column 'to' missing in table with packages (row "+c+")";if(d.timestamp)this.hasTimestamps=
this.hasTimestamps||d.timestamp;this._createPackage(d)}this._updateValueRange(this.packages)};
links.Network.prototype._filterPackages=function(a){if(this.packagesTable!=void 0){this.packages=[];for(var b=this.packagesTable,c=b.length,d=0;d<c;d++){var e=b[d];if(e.from===void 0)throw"Column 'from' missing in table with packages (row "+d+")";if(e.to===void 0)throw"Column 'to' missing in table with packages (row "+d+")";var f=e.timestamp?e.timestamp:void 0,g=!0;f!==void 0&&a!==void 0&&f>a&&(g=!1);if(g===!0&&e.progress==void 0){var i=e.duration||this.constants.packages.duration,f=(a.getTime()-
f.getTime())/1E3;if(f<i){var h=e,e={},j;for(j in h)h.hasOwnProperty(j)&&(e[j]=h[j]);e.progress=f/i}else g=!1}g===!0&&this._createPackage(e)}this.start()}};
links.Network.prototype._createPackage=function(a){var b=a.action?a.action:"create",c;if(b==="create"){if(c=a.id,b=c!==void 0?this._findPackage(c):void 0,a=new links.Network.Package(a,this,this.images,this.constants),b!==void 0?this.packages[b]=a:this.packages.push(a),a.isMoving())this.hasMovingPackages=!0}else if(b==="update"){c=a.id;if(c===void 0)throw"Cannot update a link without id";b=this._findPackage(c);if(b!==void 0)this.packages[b].setProperties(a);else if(a=new links.Network.Package(a,this,
this.images,this.constants),this.packages.push(a),a.isMoving())this.hasMovingPackages=!0}else if(b==="delete"){c=a.id;if(c===void 0)throw"Cannot delete package without its id";b=this._findPackage(c);if(b!==void 0)this.packages.splice(b,1);else throw"Package with id "+c+" not found";}else throw"Unknown action "+b+". Choose 'create', 'update', or 'delete'.";};links.Network.prototype._findPackage=function(a){for(var b=this.packages,c=0,d=b.length;c<d;c++)if(b[c].id===a)return c};
links.Network.prototype._findPackageByRow=function(a){return this.packages[a]};links.Network.prototype._getColumnNames=function(a){for(var b=a.getNumberOfColumns(),c={},d=0;d<b;d++){var e=a.getColumnLabel(d);c[e]=d}return c};links.Network.prototype._updateValueRange=function(a){var b=a.length,c,d=void 0,e=void 0;for(c=0;c<b;c++){var f=a[c].getValue();f!==void 0&&(d=d===void 0?f:Math.min(f,d),e=e===void 0?f:Math.max(f,e))}if(d!==void 0&&e!==void 0)for(c=0;c<b;c++)a[c].setValueRange(d,e)};
links.Network.prototype.setTimestamp=function(a){this._filterNodes(a);this._filterLinks(a);this._filterPackages(a)};
links.Network.prototype._getRange=function(){for(var a=void 0,b=void 0,c=[this.nodesTable,this.linksTable],d=0,e=c.length;d<e;d++){var f=c[d];if(f!==void 0)for(var g=0,i=f.length;g<i;g++){var h=f[g].timestamp;h&&(h instanceof Date&&(h=h.getTime()),a=a?Math.min(h,a):h,b=b?Math.max(h,b):h)}}if(this.packagesTable){c=this.packagesTable;d=0;for(e=c.length;d<e;d++)g=c[d],h=g.timestamp,f=g.progress,i=g.duration||this.constants.packages.duration,h instanceof Date&&(h=h.getTime()),h!=void 0&&(g=h,h=f?h:h+
i*1E3,a=a?Math.min(g,a):g,b=b?Math.max(h,b):h)}return{start:new Date(a),end:new Date(b)}};links.Network.prototype.animationStart=function(){this.slider&&this.slider.play()};links.Network.prototype.animationStop=function(){this.slider&&this.slider.stop()};links.Network.prototype.setAnimationFramerate=function(a){this.slider&&this.slider.setFramerate(a)};links.Network.prototype.setAnimationDuration=function(a){this.slider&&this.slider.setDuration(a)};
links.Network.prototype.setAnimationAcceleration=function(a){this.slider&&this.slider.setAcceleration(a)};links.Network.prototype.redraw=function(){this._setSize(this.width,this.height);this._redraw()};
links.Network.prototype._redraw=function(){var a=this.frame.canvas.getContext("2d");a.clearRect(0,0,this.frame.canvas.width,this.frame.canvas.height);a.save();a.translate(this.translation.x,this.translation.y);a.scale(this.scale,this.scale);this._drawLinks(a);this._drawNodes(a);this._drawPackages(a);this._drawSlider();a.restore()};
links.Network.prototype._setTranslation=function(a,b){if(this.translation===void 0)this.translation={x:0,y:0};if(a!==void 0)this.translation.x=a;if(b!==void 0)this.translation.y=b};links.Network.prototype._getTranslation=function(){return{x:this.translation.x,y:this.translation.y}};links.Network.prototype._setScale=function(a){this.scale=a};links.Network.prototype._getScale=function(){return this.scale};links.Network.prototype._xToCanvas=function(a){return(a-this.translation.x)/this.scale};
links.Network.prototype._canvasToX=function(a){return a*this.scale+this.translation.x};links.Network.prototype._yToCanvas=function(a){return(a-this.translation.y)/this.scale};links.Network.prototype._canvasToY=function(a){return a*this.scale+this.translation.y};links.Network.prototype._getNode=function(a){for(var b=0;b<this.nodes.length;b++)if(this.nodes[b].id==a)return this.nodes[b];return null};
links.Network.prototype._drawNodes=function(a){for(var b=this.nodes,c=[],d=0,e=b.length;d<e;d++)b[d].isSelected()?c.push(d):b[d].draw(a);d=0;for(e=c.length;d<e;d++)b[c[d]].draw(a)};links.Network.prototype._drawLinks=function(a){for(var b=this.links,c=0,d=b.length;c<d;c++)b[c].draw(a)};links.Network.prototype._drawPackages=function(a){for(var b=this.packages,c=0,d=b.length;c<d;c++)b[c].draw(a)};
links.Network.prototype._drawSlider=function(){var a;if(this.hasTimestamps){if(a=this.frame.slider,a===void 0){a=document.createElement("div");a.style.position="absolute";a.style.bottom="0px";a.style.left="0px";a.style.right="0px";a.style.backgroundColor="rgba(255, 255, 255, 0.7)";this.frame.slider=a;this.frame.slider.style.padding="10px";this.frame.appendChild(a);var b=this._getRange();this.slider=new links.Network.Slider(a);this.slider.setLoop(!1);this.slider.setRange(b.start,b.end);var c=this;
a=function(){var a=c.slider.getValue();c.setTimestamp(a);c.redraw()};this.slider.setOnChangeCallback(a);a()}}else if(a=this.frame.slider,a!==void 0)this.frame.removeChild(a),this.slider=this.frame.slider=void 0};
links.Network.prototype._reposition=function(){for(var a=this.constants.links.length*2,b=this.frame.canvas.clientWidth/2,c=this.frame.canvas.clientHeight/2,d=0;d<this.nodes.length;d++){var e=2*Math.PI*(d/this.nodes.length);if(!this.nodes[d].xFixed)this.nodes[d].x=b+a*Math.cos(e);if(!this.nodes[d].yFixed)this.nodes[d].y=c+a*Math.sin(e)}};
links.Network.prototype._doStabilize=function(){for(var a=0,b=this.constants.minVelocity,c=!1;!c&&a<this.constants.maxIterations;)this._calculateForces(),this._discreteStepNodes(),c=!this.isMoving(b),a++};
links.Network.prototype._calculateForces=function(){for(var a=this.nodes,b=this.links,c=this.frame.canvas.clientWidth/2,d=this.frame.canvas.clientHeight/2,e=0;e<a.length;e++){var f=c-a[e].x,g=d-a[e].y,f=Math.atan2(g,f),g=Math.cos(f)*0.01,f=Math.sin(f)*0.01;this.nodes[e]._setForce(g,f)}for(var d=this.constants.nodes.distance,i=10,e=0;e<a.length;e++){for(c=e+1;c<this.nodes.length;c++){var f=a[c].x-a[e].x,g=a[c].y-a[e].y,h=Math.sqrt(f*f+g*g),f=Math.atan2(g,f),h=1/(1+Math.exp((h/d-1)*i)),g=Math.cos(f)*
h,f=Math.sin(f)*h;this.nodes[e]._addForce(-g,-f);this.nodes[c]._addForce(g,f)}for(c=0;c<b.length;c++)f=b[c].from.x+(b[c].to.x-b[c].from.x)/2,g=b[c].from.y+(b[c].to.y-b[c].from.y)/2,f=a[e].x-f,g=a[e].y-g,h=Math.sqrt(f*f+g*g),f=Math.atan2(g,f),h=1/(1+Math.exp((h/(d/2)-1)*i)),g=Math.cos(f)*h,f=Math.sin(f)*h,a[e]._addForce(g,f),b[c].from._addForce(-g/2,-f/2),b[c].to._addForce(-g/2,-f/2)}c=0;for(a=b.length;c<a;c++)e=b[c],f=e.to.x-e.from.x,g=e.to.y-e.from.y,d=e.length,i=Math.sqrt(f*f+g*g),f=Math.atan2(g,
f),d=e.stiffness*(d-i),g=Math.cos(f)*d,f=Math.sin(f)*d,e.from._addForce(-g,-f),e.to._addForce(g,f);d=this.constants.links.distance;i=10;for(c=0;c<b.length;c++)for(a=c+1;a<this.links.length;a++)f=b[c].from.x+(b[c].to.x-b[c].from.x)/2,g=b[c].from.y+(b[c].to.y-b[c].from.y)/2,e=b[a].from.y+(b[a].to.y-b[a].from.y)/2,f=b[a].from.x+(b[a].to.x-b[a].from.x)/2-f,g=e-g,h=Math.sqrt(f*f+g*g),f=Math.atan2(g,f),h=1/(1+Math.exp((h/d-1)*i)),g=Math.cos(f)*h,f=Math.sin(f)*h,b[c].from._addForce(-g,-f),b[c].to._addForce(-g,
-f),b[a].from._addForce(g,f),b[a].to._addForce(g,f)};links.Network.prototype.isMoving=function(a){for(var b=this.nodes,c=0,d=b.length;c<d;c++)if(b[c].isMoving(a))return!0;return!1};links.Network.prototype._discreteStepNodes=function(){for(var a=this.refreshRate/1E3,b=this.nodes,c=0,d=b.length;c<d;c++)b[c].discreteStep(a)};links.Network.prototype._discreteStepPackages=function(){for(var a=this.refreshRate/1E3,b=this.packages,c=0,d=b.length;c<d;c++)b[c].discreteStep(a)};
links.Network.prototype._deleteFinishedPackages=function(){for(var a=0,b=!1;a<this.packages.length;)this.packages[a].isFinished()?(this.packages.splice(a,1),a--):this.packages[a].isMoving()&&(b=!0),a++;this.hasMovingPackages=b};
links.Network.prototype.start=function(){if(this.hasMovingNodes)this._calculateForces(),this._discreteStepNodes(),this.hasMovingNodes=this.isMoving(this.constants.minVelocity);this.hasMovingPackages&&(this._discreteStepPackages(),this._deleteFinishedPackages());if(this.hasMovingNodes||this.hasMovingLinks||this.hasMovingPackages){if(!this.timer){var a=this;this.timer=window.setTimeout(function(){a.timer=void 0;a.start();a._redraw()},this.refreshRate)}}else this._redraw()};
links.Network.prototype.stop=function(){if(this.timer)window.clearInterval(this.timer),this.timer=void 0};links.Network.addEventListener=function(a,b,c,d){a.addEventListener?(d===void 0&&(d=!1),b==="mousewheel"&&navigator.userAgent.indexOf("Firefox")>=0&&(b="DOMMouseScroll"),a.addEventListener(b,c,d)):a.attachEvent("on"+b,c)};
links.Network.removeEventListener=function(a,b,c,d){a.removeEventListener?(d===void 0&&(d=!1),b==="mousewheel"&&navigator.userAgent.indexOf("Firefox")>=0&&(b="DOMMouseScroll"),a.removeEventListener(b,c,d)):a.detachEvent("on"+b,c)};links.Network.stopPropagation=function(a){if(!a)a=window.event;a.stopPropagation?a.stopPropagation():a.cancelBubble=!0};links.Network.preventDefault=function(a){if(!a)a=window.event;a.preventDefault?a.preventDefault():a.returnValue=!1};
links.Network._getAbsoluteLeft=function(a){for(var b=0;a!=null;)b+=a.offsetLeft,b-=a.scrollLeft,a=a.offsetParent;!document.body.scrollLeft&&window.pageXOffset&&(b-=window.pageXOffset);return b};links.Network._getAbsoluteTop=function(a){for(var b=0;a!=null;)b+=a.offsetTop,b-=a.scrollTop,a=a.offsetParent;!document.body.scrollTop&&window.pageYOffset&&(b-=window.pageYOffset);return b};
links.Network.Node=function(a,b,c,d){this.selected=!1;this.group=d.nodes.group;this.fontSize=d.nodes.fontSize;this.fontFace=d.nodes.fontFace;this.fontColor=d.nodes.fontColor;this.borderColor=d.nodes.borderColor;this.backgroundColor=d.nodes.backgroundColor;this.highlightColor=d.nodes.highlightColor;this.id=void 0;this.style=d.nodes.style;this.image=d.nodes.image;this.y=this.x=0;this.yFixed=this.xFixed=!1;this.radius=d.nodes.radius;this.radiusFixed=!1;this.radiusMin=d.nodes.radiusMin;this.radiusMax=
d.nodes.radiusMax;this.imagelist=b;this.grouplist=c;this.setProperties(a,d);this.mass=50;this.vy=this.vx=this.fy=this.fx=0;this.damping=0.5};
links.Network.Node.prototype.setProperties=function(a,b){if(a){if(a.id!=void 0)this.id=a.id;if(a.text!=void 0)this.text=a.text;if(a.title!=void 0)this.title=a.title;if(a.group!=void 0)this.group=a.group;if(a.x!=void 0)this.x=a.x;if(a.y!=void 0)this.y=a.y;if(a.value!=void 0)this.value=a.value;if(a.timestamp!=void 0)this.timestamp=a.timestamp;if(this.id===void 0)throw"Node must have an id";if(this.group){var c=this.grouplist.get(this.group),d;for(d in c)c.hasOwnProperty(d)&&(this[d]=c[d])}if(a.style!=
void 0)this.style=a.style;if(a.image!=void 0)this.image=a.image;if(a.radius!=void 0)this.radius=a.radius;if(a.borderColor!=void 0)this.borderColor=a.borderColor;if(a.backgroundColor!=void 0)this.backgroundColor=a.backgroundColor;if(a.highlightColor!=void 0)this.highlightColor=a.highlightColor;if(a.fontColor!=void 0)this.fontColor=a.fontColor;if(a.fontSize!=void 0)this.fontSize=a.fontSize;if(a.fontFace!=void 0)this.fontFace=a.fontFace;if(this.image!=void 0)if(this.imagelist)this.imageObj=this.imagelist.load(this.image);
else throw"No imagelist provided";this.xFixed=this.xFixed||a.x!=void 0;this.yFixed=this.yFixed||a.y!=void 0;this.radiusFixed=this.radiusFixed||a.radius!=void 0;if(this.style=="image")this.radiusMin=b.nodes.widthMin,this.radiusMax=b.nodes.widthMax;switch(this.style){case "database":this.draw=this._drawDatabase;break;case "rect":this.draw=this._drawRect;break;case "circle":this.draw=this._drawCircle;break;case "image":this.draw=this._drawImage;break;case "text":this.draw=this._drawText;break;case "dot":this.draw=
this._drawDot;break;case "square":this.draw=this._drawSquare;break;case "triangle":this.draw=this._drawTriangle;break;case "triangleDown":this.draw=this._drawTriangleDown;break;case "star":this.draw=this._drawStar;break;default:this.draw=this._drawText}this.height=this.width=void 0}};links.Network.Node.prototype.select=function(){this.selected=!0;this._reset()};links.Network.Node.prototype.unselect=function(){this.selected=!1;this._reset()};
links.Network.Node.prototype._reset=function(){this.height=this.width=void 0};links.Network.Node.prototype.getTitle=function(){return this.title};links.Network.Node.prototype._setForce=function(a,b){this.fx=a;this.fy=b};links.Network.Node.prototype._addForce=function(a,b){this.fx+=a;this.fy+=b};
links.Network.Node.prototype.discreteStep=function(a){this.xFixed||(this.vx+=(this.fx+-this.damping*this.vx)/this.mass/a,this.x+=this.vx/a);this.yFixed||(this.vy+=(this.fy+-this.damping*this.vy)/this.mass/a,this.y+=this.vy/a)};links.Network.Node.prototype.isFixed=function(){return this.xFixed&&this.yFixed};links.Network.Node.prototype.isMoving=function(a){return this.vx>a||this.vx<-a||this.vy>a||this.vy<-a||!this.xFixed&&Math.abs(this.fx)>0.0050||!this.yFixed&&Math.abs(this.fy)>0.0050};
links.Network.Node.prototype.isSelected=function(){return this.selected};links.Network.Node.prototype.getValue=function(){return this.value};links.Network.Node.prototype.getDistance=function(a,b){var c=this.x-a,d=this.y-b;return Math.sqrt(c*c+d*d)};links.Network.Node.prototype.setValueRange=function(a,b){if(!this.radiusFixed&&this.value!==void 0)this.radius=(this.value-a)*((this.radiusMax-this.radiusMin)/(b-a))+this.radiusMin};
links.Network.Node.prototype.draw=function(){throw"Draw method not initialized for node";};links.Network.Node.prototype.isOverlappingWith=function(a){return this.left<a.right&&this.left+this.width>a.left&&this.top<a.bottom&&this.top+this.height>a.top};
links.Network.Node.prototype._drawImage=function(a){var b,c;this.value?(c=this.imageObj.height/this.imageObj.width,b=this.radius||this.imageObj.width,c=this.radius*c||this.imageObj.height):(b=this.imageObj.width,c=this.imageObj.height);this.left=this.x-b/2;this.top=this.y-c/2;this.width=b;this.height=c;this.imageObj?(a.drawImage(this.imageObj,this.left,this.top,b,c),b=this.y+c/2):b=this.y;this._text(a,this.text,this.x,b,void 0,"top")};
links.Network.Node.prototype._drawRect=function(a){if(!this.width){var b=this.getTextSize(a);this.width=b.width+10;this.height=b.height+10}this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a.roundRect(this.left,this.top,this.width,this.height,this.radius);a.fill();a.stroke();this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._drawDatabase=function(a){if(!this.width){var b=this.getTextSize(a).width+10;this.height=this.width=b}this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a.database(this.x-this.width/2,this.y-this.height*0.5,this.width,this.height);a.fill();a.stroke();this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._drawCircle=function(a){if(!this.width){var b=this.getTextSize(a),b=Math.max(b.width,b.height)+10;this.radius=b/2;this.height=this.width=b}this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a.circle(this.x,this.y,this.radius);a.fill();a.stroke();this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._drawDot=function(a){this._drawShape(a,"circle")};links.Network.Node.prototype._drawTriangle=function(a){this._drawShape(a,"triangle")};links.Network.Node.prototype._drawTriangleDown=function(a){this._drawShape(a,"triangleDown")};links.Network.Node.prototype._drawSquare=function(a){this._drawShape(a,"square")};links.Network.Node.prototype._drawStar=function(a){this._drawShape(a,"star")};
links.Network.Node.prototype._drawShape=function(a,b){if(!this.width){var c=2*this.radius;this.height=this.width=c}this.left=this.x-this.width/2;this.top=this.y-this.height/2;a.strokeStyle=this.borderColor;a.fillStyle=this.selected?this.highlightColor:this.backgroundColor;a.lineWidth=this.selected?2:1;a[b](this.x,this.y,this.radius);a.fill();a.stroke();this.text&&this._text(a,this.text,this.x,this.y+this.height/2,void 0,"top")};
links.Network.Node.prototype._drawText=function(a){if(!this.width){var b=this.getTextSize(a);this.width=b.width+10;this.height=b.height+10}this.left=this.x-this.width/2;this.top=this.y-this.height/2;this._text(a,this.text,this.x,this.y)};
links.Network.Node.prototype._text=function(a,b,c,d,e,f){if(b){a.font=(this.selected?"bold ":"")+this.fontSize+"px "+this.fontFace;a.fillStyle=this.fontColor||"black";a.textAlign=e||"center";a.textBaseline=f||"middle";b=b.split("\n");e=b.length;f=this.fontSize+4;d+=(1-e)/2*f;for(var g=0;g<e;g++)a.fillText(b[g],c,d),d+=f}};
links.Network.Node.prototype.getTextSize=function(a){if(this.text!=void 0){a.font=(this.selected?"bold ":"")+this.fontSize+"px "+this.fontFace;for(var b=this.text.split("\n"),c=(this.fontSize+4)*b.length,d=0,e=0,f=b.length;e<f;e++)d=Math.max(d,a.measureText(b[e]).width);return{width:d,height:c}}else return{width:0,height:0}};
links.Network.Link=function(a,b,c){if(!b)throw"No network provided";this.network=b;this.widthMin=c.links.widthMin;this.widthMax=c.links.widthMax;this.id=void 0;this.style=c.links.style;this.title=void 0;this.width=c.links.width;this.value=void 0;this.length=c.links.length;this.stiffness=void 0;this.color=c.links.color;this.timestamp=void 0;this.lengthFixed=this.widthFixed=!1;this.setProperties(a)};
links.Network.Link.prototype.setProperties=function(a){if(a){if(a.from!=void 0)this.from=this.network._getNode(a.from);if(a.to!=void 0)this.to=this.network._getNode(a.to);if(a.id!=void 0)this.id=a.id;if(a.style!=void 0)this.style=a.style;if(a.title!=void 0)this.title=a.title;if(a.width!=void 0)this.width=a.width;if(a.value!=void 0)this.value=a.value;if(a.length!=void 0)this.length=a.length;if(a.color!=void 0)this.color=a.color;if(a.timestamp!=void 0)this.timestamp=a.timestamp;if(!this.from)throw"Node with id "+
a.from+" not found";if(!this.to)throw"Node with id "+a.to+" not found";this.widthFixed=this.widthFixed||a.width!=void 0;this.lengthFixed=this.lengthFixed||a.length!=void 0;this.stiffness=1/this.length;if(this.style==="arrow")this.arrows=[0.5],this.animation=!1;else if(this.style==="moving-arrows"){this.arrows=[];for(a=0;a<3;a++)this.arrows.push(a/3);this.animation=!0}else this.style==="moving-dot"?(this.dot=0,this.animation=!0):this.animation=!1;switch(this.style){case "line":this.draw=this._drawLine;
break;case "arrow":this.draw=this._drawArrow;break;case "moving-arrows":this.draw=this._drawMovingArrows;break;case "moving-dot":this.draw=this._drawMovingDot;break;default:this.draw=this._drawLine}}};links.Network.Link.prototype.isMoving=function(){return this.animation};links.Network.Link.prototype.getTitle=function(){return this.title};links.Network.Link.prototype.getValue=function(){return this.value};
links.Network.Link.prototype.setValueRange=function(a,b){if(!this.widthFixed&&this.value!==void 0)this.width=(this.value-a)*((this.widthMax-this.widthMin)/(b-a))+this.widthMin};links.Network.Link.prototype.isLengthFixed=function(){return this.lengthFixed};links.Network.Link.prototype.getLength=function(){return this.length};links.Network.Link.prototype.setLength=function(a){if(!this.lengthFixed)this.length=a};
links.Network.Link.prototype.draw=function(){throw"Method draw not initialized in link";};links.Network.Link.prototype.isOverlappingWith=function(a){return links.Network._dist(this.from.x,this.from.y,this.to.x,this.to.y,a.left,a.top)<10};links.Network._dist=function(a,b,c,d,e,f){c-=a;d-=b;var g=((e-a)*c+(f-b)*d)/(c*c+d*d);g>1?g=1:g<0&&(g=0);a=a+g*c-e;b=b+g*d-f;return Math.sqrt(a*a+b*b)};
links.Network.Link.prototype._drawLine=function(a){a.strokeStyle=this.color;a.lineWidth=this.width;a.beginPath();a.moveTo(this.from.x,this.from.y);a.lineTo(this.to.x,this.to.y);a.stroke()};links.Network.Link.prototype._drawMovingArrows=function(a){this._drawArrow(a);for(var b in this.arrows)this.arrows.hasOwnProperty(b)&&(this.arrows[b]+=0.02,this.arrows[b]>1&&(this.arrows[b]=0))};
links.Network.Link.prototype._drawMovingDot=function(a){a.strokeStyle=this.color;a.fillStyle=this.color;a.lineWidth=this.width;a.beginPath();a.moveTo(this.from.x,this.from.y);a.lineTo(this.to.x,this.to.y);a.stroke();a.circle((1-this.dot)*this.from.x+this.dot*this.to.x,(1-this.dot)*this.from.y+this.dot*this.to.y,4+this.width*2);a.fill();this.dot+=0.05;if(this.dot>1)this.dot=0};
links.Network.Link.prototype._drawArrow=function(a){a.strokeStyle=this.color;a.fillStyle=this.color;a.lineWidth=this.width;a.beginPath();a.moveTo(this.from.x,this.from.y);a.lineTo(this.to.x,this.to.y);a.stroke();var b=Math.atan2(this.to.y-this.from.y,this.to.x-this.from.x),c=10+5*this.width,d;for(d in this.arrows)if(this.arrows.hasOwnProperty(d)){var e=this.arrows[d];a.arrow((1-e)*this.from.x+e*this.to.x,(1-e)*this.from.y+e*this.to.y,b,c);a.fill();a.stroke()}};
links.Network.Images=function(){this.images={};this.callback=void 0};links.Network.Images.prototype.setOnloadCallback=function(a){this.callback=a};links.Network.Images.prototype.load=function(a){var b=this.images[a];if(b==void 0){var c=this,b=new Image;this.images[a]=b;b.onload=function(){c.callback&&c.callback(this)};b.src=a}return b};
links.Network.Package=function(a,b,c,d){if(b==void 0)throw"No network provided";this.radiusMin=d.packages.radiusMin;this.radiusMax=d.packages.radiusMax;this.imagelist=c;this.network=b;this.title=this.to=this.from=this.id=void 0;this.style=d.packages.style;this.radius=d.packages.radius;this.color=d.packages.color;this.image=d.packages.image;this.value=void 0;this.progress=0;this.timestamp=void 0;this.duration=d.packages.duration;this.autoProgress=!0;this.radiusFixed=!1;this.setProperties(a,d)};
links.Network.Package.DEFAULT_DURATION=1;
links.Network.Package.prototype.setProperties=function(a,b){if(a){if(a.from!=void 0)this.from=this.network._getNode(a.from);if(a.to!=void 0)this.to=this.network._getNode(a.to);if(!this.from)throw"Node with id "+a.from+" not found";if(!this.to)throw"Node with id "+a.to+" not found";if(a.id!=void 0)this.id=a.id;if(a.title!=void 0)this.title=a.title;if(a.style!=void 0)this.style=a.style;if(a.radius!=void 0)this.radius=a.radius;if(a.value!=void 0)this.value=a.value;if(a.image!=void 0)this.image=a.image;
if(a.color!=void 0)this.color=a.color;if(a.progress!=void 0)this.progress=a.progress;if(a.timestamp!=void 0)this.timestamp=a.timestamp;if(a.duration!=void 0)this.duration=a.duration;this.radiusFixed=this.radiusFixed||a.radius!=void 0;this.autoProgress=this.autoProgress==!0?a.progress==void 0:!1;if(this.style=="image")this.radiusMin=b.packages.widthMin,this.radiusMax=b.packages.widthMax;if(this.progress<0)this.progress=0;if(this.progress>1)this.progress=1;if(this.image!=void 0)if(this.imagelist)this.imageObj=
this.imagelist.load(this.image);else throw"No imagelist provided";switch(this.style){case "dot":this.draw=this._drawDot;break;case "square":this.draw=this._drawSquare;break;case "triangle":this.draw=this._drawTriangle;break;case "triangleDown":this.draw=this._drawTriangleDown;break;case "star":this.draw=this._drawStar;break;case "image":this.draw=this._drawImage;break;default:this.draw=this._drawDot}}};links.Network.Package.prototype.setProgress=function(a){this.progress=a;this.autoProgress=!1};
links.Network.Package.prototype.isFinished=function(){return this.autoProgress==!0&&this.progress>=1};links.Network.Package.prototype.isMoving=function(){return this.autoProgress||this.isFinished()};links.Network.Package.prototype.discreteStep=function(a){if(this.autoProgress==!0&&(this.progress+=parseFloat(a)/this.duration,this.progress>1))this.progress=1};links.Network.Package.prototype.draw=function(){throw"Draw method not initialized for package";};
links.Network.Package.prototype.isOverlappingWith=function(a){var b=Math.max(this.radius,10),c=this._getPosition();return c.x-b<a.right&&c.x+b>a.left&&c.y-b<a.bottom&&c.y+b>a.top};links.Network.Package.prototype._getPosition=function(){return{x:(1-this.progress)*this.from.x+this.progress*this.to.x,y:(1-this.progress)*this.from.y+this.progress*this.to.y}};links.Network.Package.prototype.getTitle=function(){return this.title};links.Network.Package.prototype.getValue=function(){return this.value};
links.Network.Package.prototype.getDistance=function(a,b){var c=this._getPosition(),d=c.x-a,c=c.y-b;return Math.sqrt(d*d+c*c)};links.Network.Package.prototype.setValueRange=function(a,b){if(!this.radiusFixed&&this.value!==void 0)this.radius=(this.value-a)*((this.radiusMax-this.radiusMin)/(b-a))+this.radiusMin};links.Network.Package.prototype._drawDot=function(a){this._drawShape(a,"circle")};links.Network.Package.prototype._drawTriangle=function(a){this._drawShape(a,"triangle")};
links.Network.Package.prototype._drawTriangleDown=function(a){this._drawShape(a,"triangleDown")};links.Network.Package.prototype._drawSquare=function(a){this._drawShape(a,"square")};links.Network.Package.prototype._drawStar=function(a){this._drawShape(a,"star")};links.Network.Package.prototype._drawShape=function(a,b){a.fillStyle=this.color;var c=this._getPosition();a[b](c.x,c.y,this.radius);a.fill()};
links.Network.Package.prototype._drawImage=function(a){if(this.imageObj){var b,c;this.value?(c=this.imageObj.height/this.imageObj.width,b=this.radius||this.imageObj.width,c=this.radius*c||this.imageObj.height):(b=this.imageObj.width,c=this.imageObj.height);var d=this._getPosition();a.drawImage(this.imageObj,d.x-b/2,d.y-c/2,b,c)}else console.log("image still loading...")};links.Network.Groups=function(){this.clear();this.defaultIndex=0};
links.Network.Groups.DEFAULT=[{borderColor:"#2B7CE9",backgroundColor:"#97C2FC",highlightColor:"#D2E5FF"},{borderColor:"#FFA500",backgroundColor:"#FFFF00",highlightColor:"#FFFFA3"},{borderColor:"#FA0A10",backgroundColor:"#FB7E81",highlightColor:"#FFAFB1"},{borderColor:"#41A906",backgroundColor:"#7BE141",highlightColor:"#A1EC76"},{borderColor:"#E129F0",backgroundColor:"#EB7DF4",highlightColor:"#F0B3F5"},{borderColor:"#7C29F0",backgroundColor:"#AD85E4",highlightColor:"#D3BDF0"},{borderColor:"#C37F00",
backgroundColor:"#FFA807",highlightColor:"#FFCA66"},{borderColor:"#4220FB",backgroundColor:"#6E6EFD",highlightColor:"#9B9BFD"},{borderColor:"#FD5A77",backgroundColor:"#FFC0CB",highlightColor:"#FFD1D9"},{borderColor:"#4AD63A",backgroundColor:"#C2FABC",highlightColor:"#E6FFE3"}];links.Network.Groups.prototype.clear=function(){this.groups={};this.groups.length=function(){var a=0,b;for(b in this)this.hasOwnProperty(b)&&a++;return a}};
links.Network.Groups.prototype.get=function(a){var b=this.groups[a];if(b==void 0){var c=this.defaultIndex%links.Network.Groups.DEFAULT.length;this.defaultIndex++;b={};b.borderColor=links.Network.Groups.DEFAULT[c].borderColor;b.backgroundColor=links.Network.Groups.DEFAULT[c].backgroundColor;b.highlightColor=links.Network.Groups.DEFAULT[c].highlightColor;this.groups[a]=b}return b};links.Network.Groups.prototype.add=function(a,b){return this.groups[a]=b};
links.Network.isArray=function(a){return a instanceof Array?!0:Object.prototype.toString.call(a)==="[object Array]"};
links.Network.Slider=function(a){if(a===void 0)throw"Error: No container element defined";this.container=a;this.frame=document.createElement("DIV");this.frame.style.width="100%";this.frame.style.position="relative";this.title=document.createElement("DIV");this.title.style.margin="2px";this.title.style.marginBottom="5px";this.title.innerHTML="";this.container.appendChild(this.title);this.frame.prev=document.createElement("INPUT");this.frame.prev.type="BUTTON";this.frame.prev.value="Prev";this.frame.appendChild(this.frame.prev);
this.frame.play=document.createElement("INPUT");this.frame.play.type="BUTTON";this.frame.play.value="Play";this.frame.appendChild(this.frame.play);this.frame.next=document.createElement("INPUT");this.frame.next.type="BUTTON";this.frame.next.value="Next";this.frame.appendChild(this.frame.next);this.frame.bar=document.createElement("INPUT");this.frame.bar.type="BUTTON";this.frame.bar.style.position="absolute";this.frame.bar.style.border="1px solid red";this.frame.bar.style.width="100px";this.frame.bar.style.height=
"6px";this.frame.bar.style.borderRadius="2px";this.frame.bar.style.MozBorderRadius="2px";this.frame.bar.style.border="1px solid #7F7F7F";this.frame.bar.style.backgroundColor="#E5E5E5";this.frame.appendChild(this.frame.bar);this.frame.slide=document.createElement("INPUT");this.frame.slide.type="BUTTON";this.frame.slide.style.margin="0px";this.frame.slide.value=" ";this.frame.slide.style.position="relative";this.frame.slide.style.left="-100px";this.frame.appendChild(this.frame.slide);var b=this;this.frame.slide.onmousedown=
function(a){b._onMouseDown(a)};this.frame.prev.onclick=function(a){b.prev(a)};this.frame.play.onclick=function(a){b.togglePlay(a)};this.frame.next.onclick=function(a){b.next(a)};this.container.appendChild(this.frame);this.playTimeout=this.onChangeCallback=void 0;this.framerate=20;this.duration=10;this.doLoop=!0;this.step=this.value=this.end=this.start=0;this.rangeIsDate=!1;this.redraw()};links.Network.Slider.prototype._updateStep=function(){this.step=(this.end-this.start)/(this.duration*this.framerate)};
links.Network.Slider.prototype.prev=function(){this._setValue(this.value-this.step)};links.Network.Slider.prototype.next=function(){this._setValue(this.value+this.step)};
links.Network.Slider.prototype.playNext=function(){var a=new Date;if(!this.leftButtonDown)if(this.value+this.step<this.end)this._setValue(this.value+this.step);else if(this.doLoop)this._setValue(this.start);else{this._setValue(this.end);this.stop();return}var a=Math.max(1E3/this.framerate-(new Date-a),0),b=this;this.playTimeout=setTimeout(function(){b.playNext()},a)};links.Network.Slider.prototype.togglePlay=function(){this.playTimeout===void 0?this.play():this.stop()};
links.Network.Slider.prototype.play=function(){this.frame.play.value="Stop";this.playNext()};links.Network.Slider.prototype.stop=function(){this.frame.play.value="Play";clearInterval(this.playTimeout);this.playTimeout=void 0};links.Network.Slider.prototype.setOnChangeCallback=function(a){this.onChangeCallback=a};links.Network.Slider.prototype.setFramerate=function(a){this.framerate=a;this._updateStep()};links.Network.Slider.prototype.getFramerate=function(){return this.framerate};
links.Network.Slider.prototype.setDuration=function(a){this.duration=a;this._updateStep()};links.Network.Slider.prototype.setAcceleration=function(a){this.duration=(this.end-this.start)/1E3/a;this._updateStep()};links.Network.Slider.prototype.setLoop=function(a){this.doLoop=a};links.Network.Slider.prototype.getLoop=function(){return this.doLoop};links.Network.Slider.prototype.onChange=function(){if(this.onChangeCallback!==void 0)this.onChangeCallback()};
links.Network.Slider.prototype.redraw=function(){var a=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30;this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px";this.frame.bar.style.width=a+"px";this.frame.slide.title=this.getValue();this.frame.slide.style.left=this._valueToLeft(this.value)+"px";this.title.innerHTML=this.getValue()};
links.Network.Slider.prototype.setRange=function(a,b){a===void 0||a===null||a===NaN?(this.start=0,this.rangeIsDate=!1):a instanceof Date?(this.start=a.getTime(),this.rangeIsDate=!0):(this.start=a,this.rangeIsDate=!1);this.end=b===void 0||b===null||b===NaN?this.start instanceof Date?new Date(this.start):this.start:b instanceof Date?b.getTime():b;this.value=this.start;this._updateStep();this.redraw()};
links.Network.Slider.prototype._setValue=function(a){this.value=this._limitValue(a);this.redraw();this.onChange()};links.Network.Slider.prototype.getValue=function(){return this.rangeIsDate?new Date(this.value):this.value};links.Network.Slider.prototype.offset=3;links.Network.Slider.prototype._leftToValue=function(a){var b=parseFloat(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return this._limitValue((a-this.offset)/b*(this.end-this.start)+this.start)};
links.Network.Slider.prototype._valueToLeft=function(a){var b=parseFloat(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return(this.end>this.start?(a-this.start)/(this.end-this.start)*b:0)+this.offset};links.Network.Slider.prototype._limitValue=function(a){if(a<this.start)a=this.start;if(a>this.end)a=this.end;return a};
links.Network.Slider.prototype._onMouseDown=function(a){if(this.leftButtonDown=a.which?a.which===1:a.button===1){this.startClientX=a.clientX;this.startSlideX=parseFloat(this.frame.slide.style.left);this.frame.style.cursor="move";var b=this;this.onmousemove=function(a){b._onMouseMove(a)};this.onmouseup=function(a){b._onMouseUp(a)};links.Network.addEventListener(document,"mousemove",this.onmousemove);links.Network.addEventListener(document,"mouseup",this.onmouseup);links.Network.preventDefault(a)}};
links.Network.Slider.prototype._onMouseMove=function(a){this._setValue(this._leftToValue(this.startSlideX+(a.clientX-this.startClientX)));links.Network.preventDefault(a)};links.Network.Slider.prototype._onMouseUp=function(a){this.frame.style.cursor="auto";this.leftButtonDown=!1;links.Network.removeEventListener(document,"mousemove",this.onmousemove);links.Network.removeEventListener(document,"mouseup",this.onmouseup);links.Network.preventDefault(a)};
links.Network.Popup=function(a,b,c,d){this.container=a?a:document.body;this.y=this.x=0;this.padding=5;b!==void 0&&c!==void 0&&this.setPosition(b,c);d!==void 0&&this.setText(d);this.frame=document.createElement("div");a=this.frame.style;a.position="absolute";a.visibility="hidden";a.border="1px solid #666";a.color="black";a.padding=this.padding+"px";a.backgroundColor="#FFFFC6";a.borderRadius="3px";a.MozBorderRadius="3px";a.WebkitBorderRadius="3px";a.boxShadow="3px 3px 4px #BFBFBF";a.whiteSpace="nowrap";
this.container.appendChild(this.frame)};links.Network.Popup.prototype.setPosition=function(a,b){this.x=parseInt(a);this.y=parseInt(b)};links.Network.Popup.prototype.setText=function(a){this.frame.innerHTML=a};
links.Network.Popup.prototype.show=function(a){a===void 0&&(a=!0);if(a){var b=this.frame.clientHeight,a=this.frame.clientWidth,c=this.frame.parentNode.clientHeight,d=this.frame.parentNode.clientWidth,e=this.y-b;e+b+this.padding>c&&(e=c-b-this.padding);if(e<this.padding)e=this.padding;b=this.x;b+a+this.padding>d&&(b=d-a-this.padding);if(b<this.padding)b=this.padding;this.frame.style.left=b+"px";this.frame.style.top=e+"px";this.frame.style.visibility="visible"}else this.hide()};
links.Network.Popup.prototype.hide=function(){this.frame.style.visibility="hidden"};
links.events=links.events||{listeners:[],indexOf:function(a){for(var b=this.listeners,c=0,d=this.listeners.length;c<d;c++){var e=b[c];if(e&&e.object==a)return c}return-1},addListener:function(a,b,c){var d=this.listeners[this.indexOf(a)];d||(d={object:a,events:{}},this.listeners.push(d));a=d.events[b];a||(a=[],d.events[b]=a);a.indexOf(c)==-1&&a.push(c)},removeListener:function(a,b,c){var a=this.indexOf(a),d=this.listeners[a];if(d){var e=d.events[b];e&&(c=e.indexOf(c),c!=-1&&e.splice(c,1),e.length==
0&&delete d.events[b]);var b=0,d=d.events,f;for(f in d)d.hasOwnProperty(f)&&b++;b==0&&delete this.listeners[a]}},removeAllListeners:function(){this.listeners=[]},trigger:function(a,b,c){if(a=this.listeners[this.indexOf(a)])if(b=a.events[b])for(var a=0,d=b.length;a<d;a++)b[a](c)}};CanvasRenderingContext2D.prototype.circle=function(a,b,c){this.beginPath();this.arc(a,b,c,0,2*Math.PI,!1)};CanvasRenderingContext2D.prototype.square=function(a,b,c){this.beginPath();this.rect(a-c,b-c,c*2,c*2)};
CanvasRenderingContext2D.prototype.triangle=function(a,b,c){this.beginPath();var d=c*2,c=d/2,e=Math.sqrt(3)/6*d,d=Math.sqrt(d*d-c*c);this.moveTo(a,b-(d-e));this.lineTo(a+c,b+e);this.lineTo(a-c,b+e);this.lineTo(a,b-(d-e));this.closePath()};CanvasRenderingContext2D.prototype.triangleDown=function(a,b,c){this.beginPath();var d=c*2,c=d/2,e=Math.sqrt(3)/6*d,d=Math.sqrt(d*d-c*c);this.moveTo(a,b+(d-e));this.lineTo(a+c,b-e);this.lineTo(a-c,b-e);this.lineTo(a,b+(d-e));this.closePath()};
CanvasRenderingContext2D.prototype.star=function(a,b,c){this.beginPath();for(var d=0;d<10;d++){var e=d%2===0?c*1.3:c*0.5;this.lineTo(a+e*Math.sin(d*2*Math.PI/10),b-e*Math.cos(d*2*Math.PI/10))}this.closePath()};
CanvasRenderingContext2D.prototype.roundRect=function(a,b,c,d,e){var f=Math.PI/180;c-2*e<0&&(e=c/2);d-2*e<0&&(e=d/2);this.beginPath();this.moveTo(a+e,b);this.lineTo(a+c-e,b);this.arc(a+c-e,b+e,e,f*270,f*360,!1);this.lineTo(a+c,b+d-e);this.arc(a+c-e,b+d-e,e,0,f*90,!1);this.lineTo(a+e,b+d);this.arc(a+e,b+d-e,e,f*90,f*180,!1);this.lineTo(a,b+e);this.arc(a+e,b+e,e,f*180,f*270,!1)};
CanvasRenderingContext2D.prototype.ellipse=function(a,b,c,d){var e=c/2*0.5522848,f=d/2*0.5522848,g=a+c,i=b+d,c=a+c/2,d=b+d/2;this.beginPath();this.moveTo(a,d);this.bezierCurveTo(a,d-f,c-e,b,c,b);this.bezierCurveTo(c+e,b,g,d-f,g,d);this.bezierCurveTo(g,d+f,c+e,i,c,i);this.bezierCurveTo(c-e,i,a,d+f,a,d)};
CanvasRenderingContext2D.prototype.database=function(a,b,c,d){var e=d*(1/3),f=c/2*0.5522848,g=e/2*0.5522848,i=a+c,h=b+e,c=a+c/2,j=b+e/2,e=b+(d-e/2),d=b+d;this.beginPath();this.moveTo(i,j);this.bezierCurveTo(i,j+g,c+f,h,c,h);this.bezierCurveTo(c-f,h,a,j+g,a,j);this.bezierCurveTo(a,j-g,c-f,b,c,b);this.bezierCurveTo(c+f,b,i,j-g,i,j);this.lineTo(i,e);this.bezierCurveTo(i,e+g,c+f,d,c,d);this.bezierCurveTo(c-f,d,a,e+g,a,e);this.lineTo(a,j)};
CanvasRenderingContext2D.prototype.arrow=function(a,b,c,d){var e=a+d*0.5*Math.cos(c),f=b+d*0.5*Math.sin(c),g=a-d*0.5*Math.cos(c),i=b-d*0.5*Math.sin(c);a-=d*0.4*Math.cos(c);b-=d*0.4*Math.sin(c);var h=g+d/3*Math.cos(c+0.5*Math.PI),j=i+d/3*Math.sin(c+0.5*Math.PI);g+=d/3*Math.cos(c-0.5*Math.PI);c=i+d/3*Math.sin(c-0.5*Math.PI);this.beginPath();this.moveTo(e,f);this.lineTo(h,j);this.lineTo(a,b);this.lineTo(g,c);this.closePath()};
